. /etc/functions.sh

# Read all options from the torrc section
# Make sure this handler is not called for a list item but call the list handler
# otherwise, since both cases are handled in the same way
option_cb() {
  [ `expr match "$1" '.*_ITEM[[:digit:]]*$'` -gt 0 ] \
  || [ `expr match "$1" '.*_LENGTH$'` -gt 0 ] || list_cb $1 "$2"
}

# for each list option, add a new parameter
list_cb() {
  eval local section_type=\${CONFIG_${CONFIG_SECTION}_TYPE}
  [ "$section_type" == "torrc" ] && OPTIONS="$OPTIONS --$1 '$2'"
}

# parse the tor uci configuration
config_load tor
#disable callbacks
reset_cb

# Load addresses to bind from the client section
CONFIG_APPEND=1 config_load firewall
CONFIG_APPEND=1 config_load network
unset CONFIG_APPEND

# Handler for each proxied zone. Finds all interfaces in a zone
# and tells Tor to bind on it.
tor_handle_proxied_zone () {
  local networks
  local zone=$1
  # Handler for each zone in the system. Finds the zone with the name
  # matching the proxied zone and retrieves its interfaces.
  tor_handle_zone () {
    local name
    config_get name $1 name;
    if [ "$name" == "$zone" ]; then
      config_get networks $1 network $zone; #no option means zone==network
      return 1;
    fi
  }
  config_foreach tor_handle_zone zone
  # Tell tor to bind on the primary IP address of each interface in the zone
  for network in $networks; do
    local ipaddr
    config_get ipaddr $network ipaddr
    OPTIONS="$OPTIONS --DNSListenAddress '$ipaddr'"
    OPTIONS="$OPTIONS --TransListenAddress '$ipaddr'"
    OPTIONS="$OPTIONS --SocksListenAddress '$ipaddr'"
  done
}
# Find the ip address for interfaces in each proxied zone
config_list_foreach client zone tor_handle_proxied_zone
